package AO_Template;

use strict;


# -----------------------------------------------------------------------------

sub new_AO_template() {

  my $self      = shift;
  my $devel     = shift;
  my $logs      = shift;
  my $menus     = shift;
  my $yp_passwd = shift;
  my $config    = shift;

    $self->{DEVEL}     = $devel;
    $self->{LOGS}      = $logs;
    $self->{MENUS}     = $menus;
    $self->{PASSWD}    = $yp_passwd;
    $self->{CONFIG}    = $config;

    unless (defined $self->{MENU_STR}) {
        $self->{MENU_STR} 
            =  "\n " 
            . "\n This Module..."
            . "\n --------------"
            . "\n "
            . "\n ...has not been written yet! <return> to continue...";

      }

    # -- log which module called us :
    $logs->append("Module loaded :  " . caller());

    while(1) {
        $self->{MENUS}->put_module_main_menu($self);
        my $result = $self->do_it($self->{MENUS}->get_option());
        if ($result eq "done_it") {last}
      }
  }


# -----------------------------------------------------------------------------
# -- default sub do_it :

sub do_it() {

  my $self = shift;

    return "done_it";
  }

# -----------------------------------------------------------------------------
# -- 

sub do_it_init() {

  my $self     = shift;
  my $username = shift;

    $self->{LOGS}->append("Module called :  " . caller() . " :  " . $username);
  }

# -----------------------------------------------------------------------------
# -- attempt to do something --- returning from this subroutine will get 
#    you back to the menu "put" above;  the only way to get out of the loop
#    is to return "done_it" :

sub do_it_checks() {

  my $self      = shift;
  my $username  = shift;

    my $one = 0;
    my $two = "";

    # ..."blank to quit" (see $menu_string, above) :
    unless ($username =~ m/./) {return (1, "done_it")}

    # ...ensure we have a known user...
    unless($self->{PASSWD}->known_user($username)) {
        $self->{MENUS}->message_clr("No local account (passwd file entry) " 
                                  . "could be found: " 
                                  . $username);
        return (1, "");
      }

    # ...ensure we have the right user...
    my $correct_user 
          = $self->ensure_correct_user($self->{PASSWD}, $username);
    unless ($correct_user) {return (1, "")}


    return (0, "");
  }


# -----------------------------------------------------------------------------

sub txt_menu_str() {
    my $self = shift;

    return $self->{MENU_STR};
  }

# -----------------------------------------------------------------------------

sub ensure_correct_user() {
  my $self      = shift;
  my $yp_passwd = shift;
  my $uname     = shift;

    return 
        $self->{MENUS}->confirm("$uname <--> " . $yp_passwd->fullname($uname));

  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
