# -----------------------------------------------------------------------------
package Etc_Lin_Passwd;
# -----------------------------------------------------------------------------

use strict;
use T_Passwd;
use vars qw(@ISA);

@ISA = ("T_Passwd");


# -----------------------------------------------------------------------------
# -- CONSTRUCTOR :
# -----------------------------------------------------------------------------

sub new() {

  my $class  = shift;
  my $file   = shift;
  my $config = shift;
  my $devel  = shift;
  my $logs   = shift;

    my $self = { };

    bless($self, $class);

    $self->{CONFIG} = $config;
    $self->{DEVEL}  = $devel;
    $self->{LOGS}   = $logs;

    $self->get_self($file);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# -- NEW-ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account() {
    my $self  = shift;
    my $uname = shift;
    my $cname = shift;

    $self->{DEVEL}->marker("username: $uname");

    my $uid   = $self->{GREATEST_UID} + 1;
    my $gid   = $uid;
    my $shell = "/bin/bash";

    $self->{NEW_ACC_STR} = $uname . ":x:" . $uid . ":" . $gid . ":" 
                         . $cname . ":/home/" . $uname . ":" . $shell;

    $self->new_account_($uname, $uid, $gid, $cname, $shell);

    return (1, $uid, $gid);
  }

sub append_new_acc() {
    my $self  = shift;
    my $uname = shift;

    $self->{DEVEL}->marker("username: $uname");

    my $untainted = $self->{NEW_ACC_STR};

    unless ($untainted =~ m/^(
                             [a-zA-Z0-9]+:x:[0-9]+:[0-9]+:
                             [a-zA-Z\.\-\s]+:
                             \/home\/[a-zA-Z0-9]+:
                             \/bin\/bash
                             \s*
                            )$/x) {
        $self->{DEVEL}->die("Tainted: //$untainted//");
      }
    $untainted = $1;

    $self->append_new_acc_($untainted);
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
