# -----------------------------------------------------------------------------
package T_Auto_Home;
# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR :
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

sub get_self() {

  my $self = shift;
  my $file = shift;
    my $export   = $self->{CONFIG}->export();
    my $hostname = $self->{CONFIG}->hostname();

    open(DATA, $file) || $self->{DEVEL}->die("Can't open $file");

    my ($uname, $homedir, $host, $slice);
 
    while (my $textline = <DATA>) {

        # ...we only return /export/u0[0-9] slices :

        unless ($textline =~ m/^[a-z0-9]+\s+
                                $hostname\:$export
                                \/u0[0-9]\/[a-z0-9]+$/x) {
            next;
          }

        $textline =~ s/\n//g;
        $textline =~ s/\r//g;

        ($uname, $homedir) = split(/\s+/, $textline);
        ($host, $slice)    = split(/\:/, $homedir);

        $self->{$uname}->{SLICE} = $slice;
      }

    close(DATA);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- NEW ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account() {
    my $self  = shift;
    my $uname = shift;

    $self->{DEVEL}->marker("username: $uname");

    $self->{NEW_ACC_STR} = "$uname \t " . $self->{CONFIG}->hostname() 
                         . ":" . $self->{CONFIG}->new_home_dir_partition()
                         . "/" . $uname;

    $self->{DEVEL}->output($self->{NEW_ACC_STR});

    return 1;
  }


sub append_new_acc() {
    my $self  = shift;
    my $uname = shift;

    $self->{DEVEL}->marker("username: $uname");

    my $untainted = $self->{NEW_ACC_STR};
    my $export    = $self->{CONFIG}->export();
    my $hostname  = $self->{CONFIG}->hostname();

    unless ($untainted =~ m/^(
                            [a-zA-Z0-9]+                             # uname
                            \s+$hostname:$export
                            \/u0\d?\/m[a-z0-9]+\s* # dir
                            )$/x) {
        $self->{DEVEL}->die("Tainted: $untainted");
      }
    $untainted = $1;

    system("/bin/echo $untainted >> " 
         . $self->{CONFIG}->passwd_dir() 
         . "/auto_home"); 

    $self->{LOGS}->append_new_acc("Appended to auto_home: " 
                                . $self->{NEW_ACC_STR});
  }


# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------

my $no_slice_found = "no_slice_found";

sub slice() {
    my $self  = shift;
    my $uname = shift;

    if (defined $self->{$uname}->{SLICE}) {
        return $self->{$uname}->{SLICE};
      }
    else {
        return $no_slice_found;
      }
  }

sub no_slice_found() {
    my $self  = shift;
    return $no_slice_found;
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
