# -----------------------------------------------------------------------------
package T_Passwd_Adj;
# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR :
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

sub get_self() {

  my $self     = shift;
  my $file     = shift;

    $self->{FILE} = $file;

    my $textline = "";

    open(DATA, $file) 
        || die "\n\n Can't open $file\n\n";

    my ($uname, $passwd);
    my $i = 0;
 
    while ($textline = <DATA>) {

        $textline =~ s/\n//g;
        $textline =~ s/\r//g;

        ($uname, $passwd) = split(/\:/, $textline);

        $self->{$uname}->{PASSWD} = $passwd;
        $self->{$uname}->{COUNT}  = $i++;
      }

    close(DATA);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- NEW-ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account_() {

  my $self  = shift;
  my $uname = shift;

    # -- get a random password :

    srand(time() ^ ($$ + ($$ << 15)));

    my(@salt_set_letters)=('a'..'z');
    my(@salt_set_numbers)=(2,3,4,5,6,7,8,9);
    my(@random, $i, $password);

    $password="";

    for ($i = 0; $i < 4; $i++) {
        $random[$i] = $salt_set_letters[int(rand 26)];
        $password   = $password . $random[$i];
      }

    for ($i = 0; $i < 2; $i++) {
        $random[$i] = $salt_set_numbers[int(rand 8)];
        $password   = $password . $random[$i];
      }


    # -- encrypt it :

    my(@salt_set) = ('a'..'z','A'..'Z','0'..'9','.','/');
    my($nsalt, $random1, $random2);

    $random1 = int(rand 64); 
    $random2 = int(rand 64); 

    $nsalt = $salt_set[$random1] . $salt_set[$random2];

    my $crypt_passwd = crypt($password, $nsalt);

    return ($password, $crypt_passwd);
  }


# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------

sub users() {
    my $self = shift;

    my @users = keys %$self;

    return \@users;
  }


sub grep_users() {
    my $self = shift;
    my $str  = shift;

    my @users   = keys %$self;
    my @matches = ();

    foreach (@{$self->users()}) {
        if ($_ =~ m/$str/) {
            push(@matches, $_);
          }
      }

    return \@matches;
  }


# -----------------------------------------------------------------------------
# -- SPECIALS :
# -----------------------------------------------------------------------------

sub full_grep_users() {
    my $self = shift;
    my $str  = shift;

    # ...ensure find n copies if such exists...
    # ...ensure find n copies if such exists...

    open(DATA, "< " .$self->{FILE}) 
        || die "\n\n Can't open < " . $self->{FILE} . "\n\n";

    my ($uname, $uid, $gid, $fullname, $homedir, $shell);
    my @matches = ();

    while (my $textline = <DATA>) {

        $textline =~ s/\n//g;
        $textline =~ s/\r//g;

        ($uname,    undef,    $uid, $gid, 
         $fullname, $homedir, $shell) = split(/\:/, $textline);

        if ($uname =~ m/$str/) {
            push(@matches, $uname);
          }
      }
    close(DATA);

    return \@matches;
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
