# -----------------------------------------------------------------------------
package YP_Sol_Passwd_Adj;
# -----------------------------------------------------------------------------

use strict;
use T_Passwd_Adj;
use vars qw(@ISA);

@ISA = ("T_Passwd_Adj");

# -----------------------------------------------------------------------------
# --

sub new() {

  my $class  = shift;
  my $file   = shift;
  my $config = shift;
  my $devel  = shift;
  my $logs   = shift;

    my $self  = { };

    bless($self, $class);

    $self->{CONFIG} = $config;
    $self->{DEVEL}  = $devel;
    $self->{LOGS}   = $logs;

    $self->get_self($file);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# -- NEW-ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account() {

  my $self  = shift;
  my $uname = shift;

    if ($self->{DEVEL}->debug()) {
        $self->{DEVEL}->marker("username: $uname");
      }

    my ($passwd, $crypt_passwd) = $self->new_account_($uname);

    # -- construct file entry :

    $self->{NEW_ACC_STR} = "LDAP_" . $uname . ":" . $crypt_passwd . ":::::";

    $self->{DEVEL}->output($self->{NEW_ACC_STR});

    return (1, $passwd)
  }


sub append_new_acc() {
    my $self  = shift;
    my $uname = shift;

    if ($self->{DEVEL}->debug()) {
        $self->{DEVEL}->marker("username: $uname");
      }

    my $untainted = $self->{NEW_ACC_STR};

    unless ($untainted =~ m/^(
                            LDAP_[a-zA-Z0-9]+\:
                            [a-zA-Z0-9\.\/]+\:\:\:\:\:
                            )$/x) {
        $self->{DEVEL}->die("Tainted: $untainted");
      }
    $untainted = $1;

    system("/bin/echo $untainted >> " 
         . $self->{CONFIG}->passwd_sec_dir() 
         . "/passwd.adjunct"); 

    $self->{LOGS}->append_new_acc("Appended to adjunct:" 
                                . $self->{NEW_ACC_STR}); 
  }


# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
